#include <digitalWriteFast.h>
#include <SPI.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfSoftwareSpiDriver.h>

#define MAX_BUFF 5 //Буфер приёма-передачи
#define RF_CHANNEL 90;

char rf_buff[MAX_BUFF];

MirfSoftwareSpiDriver MirfSoftwareSpi;

#define HOME_ADDR "home"
#define RX_ADDR "addr"

#define ch_cnt 4
uint8_t ch_pin[ch_cnt] = {0,1,2,3};
uint8_t led_pin[ch_cnt] = {6,5,9,3};
int ch[ch_cnt];
int ch_prev[ch_cnt];

void setup()
{
  MirfSoftwareSpi.set_pins(7, 11, 12);
  Mirf.spi = &MirfSoftwareSpi;
  Mirf.cePin = 8;
  Mirf.csnPin = 13;
  Mirf.init();
 
  Mirf.setRADDR((byte *)RX_ADDR);
  Mirf.payload = MAX_BUFF; 
  Mirf.channel = RF_CHANNEL;
  Mirf.config();   
  
  Serial.begin(9600);
  pinMode(10,OUTPUT);
  analogWrite(10,2);
  for(int i=0;i<ch_cnt;i++) {
    pinMode(led_pin[i],OUTPUT);
    ch_prev[i] = 0;
  }
  ch_read();
  SendPacket();
}

boolean do_send = false;
void loop()
{
  ch_read();
  int a;
  for(int i=0;i<ch_cnt;i++){
    a = ch[i] - ch_prev[i];
    do_send = (abs(a)>2) | do_send;
  }
  if (do_send)
  for(int i=0;i<ch_cnt;i++){
    ch_prev[i] = ch[i];
  }
//  Serial.println(do_send);
  if (do_send) SendPacket();
  delay(100);
}

void SendPacket()
{
  for(int i=0;i<ch_cnt;i++)
    rf_buff[i]=ch[i];
  Mirf.setTADDR((byte *)HOME_ADDR);
  Serial.print("ch=");Serial.println(ch[0]);
  for(int i=0;i<10;i++)
  {
    Mirf.send((uint8_t *)rf_buff);
    while(Mirf.isSending()){
    }
  }

  do_send = false;
  delay(10);
}

void ch_read()
{
  for(int i=0;i<ch_cnt;i++) {
    ch[i]=(analogRead(ch_pin[i])>>2);
    //Serial.print("ch=");Serial.println(ch[0]);
    analogWrite(led_pin[i], ch[i]);
  }
}
